def load_data():
    data = []
    for line in open('bluebikes.csv'):
        start_time, duration, distance = line.strip().split(',')
        data.append([start_time, int(duration), float(distance)])
    return data

def avg(any_list):
    return sum(any_list)/len(any_list)

def get_hour(timestamp):
    return int(timestamp[11:13])

def remove_outliers(data):
    return [row for row in data if row[2] <= 10]


def get_day(data, day):
    return [row for row in data if row[0][:10] == day]

def count_hours_1(data):
    hour_counts = []
    for current_hour in range(24):
        current_counter = sum([1 for row in data if get_hour(row[0]) == current_hour])
        hour_counts.append(current_counter)
    return hour_counts

def count_hours_2(data):
    hour_counts = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    # you can also do it like this:
    # hour_counts = [0] * 24
    for row in data:
        current_hour = get_hour(row[0])
        hour_counts[current_hour] += 1
    return hour_counts

def rush_hours_1(hour_counts):
    sorted_counts = sorted(hour_counts)
    rush_hours = []
    for top_hour in range(4):
        rush_hours.append(hour_counts.index(sorted_counts[-top_hour-1]))
    return rush_hours

def rush_hours_2(hour_counts):
    sorted_counts = sorted(hour_counts, reverse=True) # reverse sorting
    rush_hours = []
    for top_hour in range(4):
        rush_hours.append(hour_counts.index(sorted_counts[top_hour]))
    return rush_hours



def main():
    data = load_data()
    clean_data = remove_outliers(data)


    # Exercise 4:
    aug_1 = get_day(clean_data, '2019-08-01')
    hour_counts = count_hours_2(aug_1)
    print(rush_hours_2(hour_counts))

main()